---
title: Update an environment
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Feature Flags
---

# Update an environment{% #update-an-environment %}
Copy pageCopied
{% tab title="v2" %}

| Datadog site      | API endpoint                                                                         |
| ----------------- | ------------------------------------------------------------------------------------ |
| ap1.datadoghq.com | PUT https://api.ap1.datadoghq.com/api/v2/feature-flags/environments/{environment_id} |
| ap2.datadoghq.com | PUT https://api.ap2.datadoghq.com/api/v2/feature-flags/environments/{environment_id} |
| app.datadoghq.eu  | PUT https://api.datadoghq.eu/api/v2/feature-flags/environments/{environment_id}      |
| app.ddog-gov.com  | PUT https://api.ddog-gov.com/api/v2/feature-flags/environments/{environment_id}      |
| us2.ddog-gov.com  | PUT https://api.us2.ddog-gov.com/api/v2/feature-flags/environments/{environment_id}  |
| app.datadoghq.com | PUT https://api.datadoghq.com/api/v2/feature-flags/environments/{environment_id}     |
| us3.datadoghq.com | PUT https://api.us3.datadoghq.com/api/v2/feature-flags/environments/{environment_id} |
| us5.datadoghq.com | PUT https://api.us5.datadoghq.com/api/v2/feature-flags/environments/{environment_id} |

### Overview

Updates an existing environment's metadata such as name and description. This endpoint requires the `feature_flag_environment_config_write` permission.

### Arguments

#### Path Parameters

| Name                             | Type   | Description                |
| -------------------------------- | ------ | -------------------------- |
| environment_id [*required*] | string | The ID of the environment. |

### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field | Field                         | Type     | Description                                                                  |
| ------------ | ----------------------------- | -------- | ---------------------------------------------------------------------------- |
|              | data [*required*]        | object   | Data for updating an environment.                                            |
| data         | attributes [*required*]  | object   | Attributes for updating an environment.                                      |
| attributes   | is_production                 | boolean  | Indicates whether this is a production environment.                          |
| attributes   | name                          | string   | The name of the environment.                                                 |
| attributes   | queries                       | [string] | List of queries to define the environment scope.                             |
| attributes   | require_feature_flag_approval | boolean  | Indicates whether feature flag changes require approval in this environment. |
| data         | type [*required*]        | enum     | The resource type. Allowed enum values: `environments`                       |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "is_production": false,
      "name": "Environment XYZ789",
      "queries": [
        "staging",
        "test"
      ],
      "require_feature_flag_approval": true
    },
    "type": "environments"
  }
}
```

{% /tab %}

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
Response containing an environment.

| Parent field | Field                         | Type      | Description                                                                  |
| ------------ | ----------------------------- | --------- | ---------------------------------------------------------------------------- |
|              | data [*required*]        | object    | A feature flag environment resource.                                         |
| data         | attributes [*required*]  | object    | Attributes of an environment.                                                |
| attributes   | created_at                    | date-time | The timestamp when the environment was created.                              |
| attributes   | description                   | string    | The description of the environment.                                          |
| attributes   | is_production                 | boolean   | Indicates whether this is a production environment.                          |
| attributes   | key                           | string    | The unique key of the environment.                                           |
| attributes   | name [*required*]        | string    | The name of the environment.                                                 |
| attributes   | queries                       | [string]  | List of queries to define the environment scope.                             |
| attributes   | require_feature_flag_approval | boolean   | Indicates whether feature flag changes require approval in this environment. |
| attributes   | updated_at                    | date-time | The timestamp when the environment was last updated.                         |
| data         | id [*required*]          | uuid      | The unique identifier of the environment.                                    |
| data         | type [*required*]        | enum      | The resource type. Allowed enum values: `environments`                       |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "created_at": "2023-01-01T00:00:00Z",
      "description": "Test environment XYZ789",
      "is_production": false,
      "key": "env-search-term",
      "name": "env-search-term",
      "queries": [
        "staging",
        "test"
      ],
      "require_feature_flag_approval": false,
      "updated_at": "2023-01-01T00:00:00Z"
    },
    "id": "550e8400-e29b-41d4-a716-446655440001",
    "type": "environments"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
Not Found
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Path parameters export environment_id="550e8400-e29b-41d4-a716-446655440001" \# Curl command curl -X PUT "https://api.datadoghq.com/api/v2/feature-flags/environments/${environment_id}" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "name": "production-environment",
      "queries": [
        "production",
        "prod-us"
      ]
    },
    "type": "environments"
  }
}
EOF 
                
##### 

```python
"""
Update an environment returns "OK" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.feature_flags_api import FeatureFlagsApi
from datadog_api_client.v2.model.update_environment_attributes import UpdateEnvironmentAttributes
from datadog_api_client.v2.model.update_environment_data import UpdateEnvironmentData
from datadog_api_client.v2.model.update_environment_data_type import UpdateEnvironmentDataType
from datadog_api_client.v2.model.update_environment_request import UpdateEnvironmentRequest

# there is a valid "environment" in the system
ENVIRONMENT_DATA_ID = environ["ENVIRONMENT_DATA_ID"]

body = UpdateEnvironmentRequest(
    data=UpdateEnvironmentData(
        type=UpdateEnvironmentDataType.ENVIRONMENTS,
        attributes=UpdateEnvironmentAttributes(
            name="Updated Test Environment Example-Feature-Flag",
            queries=[
                "updated-Example-Feature-Flag",
                "live-Example-Feature-Flag",
            ],
        ),
    ),
)

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = FeatureFlagsApi(api_client)
    response = api_instance.update_feature_flags_environment(environment_id=ENVIRONMENT_DATA_ID, body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Update an environment returns "OK" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::FeatureFlagsAPI.new

# there is a valid "environment" in the system
ENVIRONMENT_DATA_ID = ENV["ENVIRONMENT_DATA_ID"]

body = DatadogAPIClient::V2::UpdateEnvironmentRequest.new({
  data: DatadogAPIClient::V2::UpdateEnvironmentData.new({
    type: DatadogAPIClient::V2::UpdateEnvironmentDataType::ENVIRONMENTS,
    attributes: DatadogAPIClient::V2::UpdateEnvironmentAttributes.new({
      name: "Updated Test Environment Example-Feature-Flag",
      queries: [
        "updated-Example-Feature-Flag",
        "live-Example-Feature-Flag",
      ],
    }),
  }),
})
p api_instance.update_feature_flags_environment(ENVIRONMENT_DATA_ID, body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// Update an environment returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
	"github.com/google/uuid"
)

func main() {
	// there is a valid "environment" in the system
	EnvironmentDataID := uuid.MustParse(os.Getenv("ENVIRONMENT_DATA_ID"))

	body := datadogV2.UpdateEnvironmentRequest{
		Data: datadogV2.UpdateEnvironmentData{
			Type: datadogV2.UPDATEENVIRONMENTDATATYPE_ENVIRONMENTS,
			Attributes: datadogV2.UpdateEnvironmentAttributes{
				Name: datadog.PtrString("Updated Test Environment Example-Feature-Flag"),
				Queries: []string{
					"updated-Example-Feature-Flag",
					"live-Example-Feature-Flag",
				},
			},
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewFeatureFlagsApi(apiClient)
	resp, r, err := api.UpdateFeatureFlagsEnvironment(ctx, EnvironmentDataID, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `FeatureFlagsApi.UpdateFeatureFlagsEnvironment`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `FeatureFlagsApi.UpdateFeatureFlagsEnvironment`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Update an environment returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.FeatureFlagsApi;
import com.datadog.api.client.v2.model.EnvironmentResponse;
import com.datadog.api.client.v2.model.UpdateEnvironmentAttributes;
import com.datadog.api.client.v2.model.UpdateEnvironmentData;
import com.datadog.api.client.v2.model.UpdateEnvironmentDataType;
import com.datadog.api.client.v2.model.UpdateEnvironmentRequest;
import java.util.Arrays;
import java.util.UUID;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    FeatureFlagsApi apiInstance = new FeatureFlagsApi(defaultClient);

    // there is a valid "environment" in the system
    UUID ENVIRONMENT_DATA_ID = null;
    try {
      ENVIRONMENT_DATA_ID = UUID.fromString(System.getenv("ENVIRONMENT_DATA_ID"));
    } catch (IllegalArgumentException e) {
      System.err.println("Error parsing UUID: " + e.getMessage());
    }

    UpdateEnvironmentRequest body =
        new UpdateEnvironmentRequest()
            .data(
                new UpdateEnvironmentData()
                    .type(UpdateEnvironmentDataType.ENVIRONMENTS)
                    .attributes(
                        new UpdateEnvironmentAttributes()
                            .name("Updated Test Environment Example-Feature-Flag")
                            .queries(
                                Arrays.asList(
                                    "updated-Example-Feature-Flag", "live-Example-Feature-Flag"))));

    try {
      EnvironmentResponse result =
          apiInstance.updateFeatureFlagsEnvironment(ENVIRONMENT_DATA_ID, body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling FeatureFlagsApi#updateFeatureFlagsEnvironment");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// Update an environment returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_feature_flags::FeatureFlagsAPI;
use datadog_api_client::datadogV2::model::UpdateEnvironmentAttributes;
use datadog_api_client::datadogV2::model::UpdateEnvironmentData;
use datadog_api_client::datadogV2::model::UpdateEnvironmentDataType;
use datadog_api_client::datadogV2::model::UpdateEnvironmentRequest;

#[tokio::main]
async fn main() {
    // there is a valid "environment" in the system
    let environment_data_id = uuid::Uuid::parse_str(&std::env::var("ENVIRONMENT_DATA_ID").unwrap())
        .expect("Invalid UUID");
    let body = UpdateEnvironmentRequest::new(UpdateEnvironmentData::new(
        UpdateEnvironmentAttributes::new()
            .name("Updated Test Environment Example-Feature-Flag".to_string())
            .queries(vec![
                "updated-Example-Feature-Flag".to_string(),
                "live-Example-Feature-Flag".to_string(),
            ]),
        UpdateEnvironmentDataType::ENVIRONMENTS,
    ));
    let configuration = datadog::Configuration::new();
    let api = FeatureFlagsAPI::with_config(configuration);
    let resp = api
        .update_feature_flags_environment(environment_data_id.clone(), body)
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Update an environment returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.FeatureFlagsApi(configuration);

// there is a valid "environment" in the system
const ENVIRONMENT_DATA_ID = process.env.ENVIRONMENT_DATA_ID as string;

const params: v2.FeatureFlagsApiUpdateFeatureFlagsEnvironmentRequest = {
  body: {
    data: {
      type: "environments",
      attributes: {
        name: "Updated Test Environment Example-Feature-Flag",
        queries: ["updated-Example-Feature-Flag", "live-Example-Feature-Flag"],
      },
    },
  },
  environmentId: ENVIRONMENT_DATA_ID,
};

apiInstance
  .updateFeatureFlagsEnvironment(params)
  .then((data: v2.EnvironmentResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
